/***************************************************************************
                          settings.cpp  -  description
                             -------------------
    begin                : Die Aug 6 2002
    copyright            : (C) 2002 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "settings.h"
#include "paths.h"

#include <qvariant.h>
#include <qlayout.h>
#include <qlistview.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qobject.h>
#include <qbutton.h>
#include <qcheckbox.h>
#include <qspinbox.h>

#include <klocale.h>
#include <kiconloader.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <kfontcombo.h>
#include <kcolorbutton.h>
#include <kfiledialog.h>
#include <kurl.h>

Settings::Settings(QWidget *parent, const char *name ) : KDialogBase(IconList, i18n("Settings"), Help | Ok | Cancel, Ok,
                                                                                                          parent, name, false, true ) {
	QFrame *pathFrame    = addPage( i18n( "RPM Paths" ) ,i18n( "RPM Paths" ) ,
						KGlobal::instance()->iconLoader()->loadIcon( "rpm" ,KIcon::NoGroup , KIcon::SizeMedium ) );

	QVBoxLayout *pathLayout    = new QVBoxLayout( pathFrame );

	pathPage    = new Paths( pathFrame , "Paths" );

	pathLayout->addWidget(pathPage);

	connect((QObject*)pathPage->searchSource,SIGNAL(clicked()),this,SLOT(slotSearchSource()));
	connect((QObject*)pathPage->searchSpecs,SIGNAL(clicked()),this,SLOT(slotSearchSpecs()));

}
Settings::~Settings(){
}
/** No descriptions */
void Settings::slotSearchSpecs(){
	KURL srcURL( KFileDialog::getExistingDirectory( QString::null,this, i18n("SPECS directory") ) );
	if(srcURL.path(true).isEmpty() )return;
	pathPage->m_specs->setText(srcURL.path(true));

}
/** No descriptions */
void Settings::slotSearchSource(){
	KURL srcURL( KFileDialog::getExistingDirectory( QString::null,this, i18n("SOURCES directory") ) );
	if(srcURL.path(true).isEmpty() )return;
	pathPage->m_source->setText(srcURL.path(true));

}
/** No descriptions */
void Settings::slotOk(){
	QDir d1(pathPage->m_source->text() );
	QDir d2(pathPage->m_specs->text() );
	if(!d1.exists() || pathPage->m_source->text().isEmpty() ){
		KMessageBox::error(this,i18n("The selected directory does not exists!") + "\n" + pathPage->m_source->text() );
		return ;
	}
	if(!d2.exists() || pathPage->m_specs->text().isEmpty() ){
		KMessageBox::error(this,i18n("The selected directory does not exists!") + "\n" + pathPage->m_specs->text() );
		return ;
	}
	accept();
}
